// pages/add/add.js
const app = getApp()
const cell = [0, 288, 100, 1000, 10000]
var lock = require('../../utils/lock.js')
var net = require('../../utils/net.js')
var url = require('../../utils/url.js')
var common = require('../../utils/common.js')

Page({

  /**
   * 页面的初始数据
   */
  data: {
    getPhoneCell: '200万',
    canPay: false,
    canNotPay: '',
    options: [],
    selected: '',
    phone: ''
  },

  buyAction: function () {
    // wx.showModal({
    //   title: '提示',
    //   content: '获取更多脑力值，关注公众号【冲顶王者】',
    //   showCancel: false,
    //   success: res => {

    //   }
    // })
    // return

    // console.log(this.data.selected)
    wx.showLoading({
      title: '正在打赏',
    })
    this.getOrder({
      url: url.host + url.recharge,
      data: {
        cellProductId: this.data.selected
      },
      success: res => {
        wx.hideLoading()
        // app.globalData.user.cell += cell[Number(this.data.selected)]
        var len = this.data.options.length || 0
        for (var i = 0; i < len; i++) {
          if (this.data.options[i].cellProductId == this.data.selected) {
            var title = '+' + common.unit(this.data.options[i].cell)

            if (this.data.options[i].type == 1) {
              this.data.options.splice(i, 1)
              this.data.options[0].selected = true
              var selected = this.data.options[0].cellProductId || 0
              this.setData({
                selected: selected,
                options: this.data.options
              })
            }

            break
          }
        }
        
        wx.showToast({
          duration: 2000,
          icon: 'none',
          title: title
        })
      }
    })
  },


  //获取订单接口
  getOrder: function (obj)  {
    net.connect({
      url: obj.url,
      data: obj.data,
      method: 'POST',
      success: res => {
        this.order(obj, res.data.data)
      }
    })
  },
  //微信支付统一调用接口
  order: function (obj, order)  {
    if (app.globalData.debug) {
      net.connect({
        url: url.host + url.testPay,
        data: { out_trade_no: order },
        success: res => {
          obj.success(res)
        }
      })
      return
    }

    net.connect({
      url: url.host + url.unified,
      data: { out_trade_no: order },
      method: 'POST',
      success: res => {
        this.pay(obj, order, res.data.data)
      }
    })
  },
  //微信支付
  pay: function (obj, no, order)  {
    wx.requestPayment({
      timeStamp: order.timeStamp,
      nonceStr: order.nonceStr,
      package: order.package,
      signType: 'MD5',
      paySign: order.paySign,
      success: res => {
        obj.success(res)
      },
      fail: e => {
        wx.hideLoading()
        wx.showModal({
          title: '',
          content: '支付失败',
        })
      }
    })
  },

  selectAction: function (o) {
    app.log(o.currentTarget.id)
    var id = o.currentTarget.id
    var len = this.data.options.length || 0
    for (var i = 0; i < len; i++) {
      if (this.data.options[i].cellProductId == id) {
        var selected = id
        this.data.options[i].selected = true
      } else {
        this.data.options[i].selected = false
      }
    }
    // console.log(selected)
    this.setData({
      options: this.data.options,
      selected: selected
    })
  },

  getPhoneNumber: function (e) {
    if (e.detail.errMsg == 'getPhoneNumber:ok') {
      // console.log('获取了')
      wx.showLoading({
        title: '',
      })
      net.connect({
        url: url.host + url.bind_phone,
        data: { 
          encryptedData: e.detail.encryptedData,
          iv: e.detail.iv
           },
        method: 'POST',
        success: res => {
          wx.hideLoading()
          app.globalData.user.cell += res.data.data.addCell
          this.setData({
            phone: res.data.data.phone,
          })
          wx.showToast({
            duration: 2000,
            icon: 'none',
            title: '+' + res.data.data.addCell + '万',
          })
          // console.log(res.data.data)
        }
      })
    }
    // console.log(e.detail.errMsg)
    // console.log(e.detail.iv)
    // console.log(e.detail.encryptedData)
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    app.log(app.globalData.user)
    var phone = app.server.phone || ''
    var options = app.globalData.user.cellProductList
    var len = options.length || 0
    for (var i = 0; i < len; i++) {
      if (i == 0) {
        options[i].selected = true
      } else {
        options[i].selected = false
      }
    }
    //  [
    //   { id: '1', title: '288万脑力值', menoy: '¥ 1', hidden: !app.globalData.canFirstCell, selected: true },
    //   { id: '2', title: '100万脑力值', menoy: '¥ 1', selected: !app.globalData.canFirstCell },
    //   { id: '3', title: '1000万脑力值', menoy: '¥ 9', selected: false },
    //   { id: '4', title: '1亿脑力值', menoy: '¥ 88', selected: false }
    // ]
    var selected = options[0].cellProductId || 0
    if (app.server.config.cellBindPhone) {
      this.data.getPhoneCell = common.unit(app.server.config.cellBindPhone)
    }
    this.setData({
      getPhoneCell: this.data.getPhoneCell,
      canPay: !app.globalData.isIOS,
      canNotPay: app.server.config.noSupportPayMsg,
      options: options,
      phone: phone,
      selected: selected
    })
    // console.log(selected)
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  // onShareAppMessage: function () {

  // }
})
