// pages/room/room.js
// CELL_LACK(20001, "脑力值不足"),
// ROOM_FULL(20002, "房间满员"),
// ROOM_BEGIN(20003, "房间已开始"),
// ROOM_END(20004, "房间已结束"),
// ROOM_PRIVATE(20005, "没有权限"),
// ROOM_RETRY(20006, "没有到可查询时间"),
// 20007答题结束
//2008重复答题
import NumberTimeChange from '../../utils/ntc.js'
const app = getApp()

var net = require('../../utils/net.js')
var url = require('../../utils/url.js')
var common = require('../../utils/common.js')

Page({

  /**
   * 页面的初始数据
   */
  data: {
    network: {
      shareUserId: '',
      countDown: 0,
      problem: false,
      getting: true
    },
    interval: 1,
    isFirstLoad: true,
    questionId: 0,
    lastQuestion: false,
    reloadQuestion: false,
    getInfo: false,//判断获取到房间信息没有
    getDynamicInfo: false,//判断是否开始取动态数据
    rollAnimation:{},
    gameId: '',
    roomInfo: {
      awardFee: 0,
      awardUser: 0,
      curUser: 0,
      ref:1,//房间类型1是平台，2是用户
    },
    adapter: {
      animation: 's'
    },
    questionType:[],
    question: { 
      n: '', 
      t: '', 
      q: '', 
      o: ['', '', '', ''], 
      id:''
    },
    questionNum: 0,
    optionsStyle: ['w', 'w', 'w', 'w'],//w未选,t正确，f错误，q其他,s选择
    status: 0,//0是倒数阶段，1是答题阶段，2是结果有红包，3是结果没有红包, 4是答题前展示
    invite: {
      shareButton: '邀请好友一起来瓜分奖金',
      shareTips1: '队友越多、奖励概率越大、瓜分奖金也越多',
      shareTips2: '其中第一名最高可独占90%奖金'
    },
    result:{
      bonus: 0,
      tips: '',
      shareButton: '',
      shareTips: '',
      openType: 'share',
    },
    share: {
      t: 0, //结果分享0分享房间，1增加脑力值，2翻倍,3图片, 4无奖励
      s: 0,// 状态，0无分享，1增加脑力值，2翻倍
      bonus: 0,
      cell: 0,
    },
    answer: {
      tips: '答题倒计时',//答题倒计时文案
      integral: 0,
      status: -1,//-1未答题，0已经答题，1答对，2答错
    },
    sponsor: { name: ' ', icon: '' },
    countDown: '0',
    animation: {
      status: 0,//0未答题，1答对，2答错,
      backgroundStyle: 'opacity: 0;'
    },
    alwaysGetRanking: false,//最后一题一直取排行榜
    ranking: [
      { indexL: '01', avatarL: '', nameL: '', countL: '', isSelfL: false, indexR: '02', avatarR: '', nameR: '', countR: '', isSelfR: false },
      { indexL: '03', avatarL: '', nameL: '', countL: '', isSelfL: false, indexR: '04', avatarR: '', nameR: '', countR: '', isSelfR: false },
      { indexL: '05', avatarL: '', nameL: '', countL: '', isSelfL: false, indexR: '06', avatarR: '', nameR: '', countR: '', isSelfR: false },
      { indexL: '07', avatarL: '', nameL: '', countL: '', isSelfL: false, indexR: '08', avatarR: '', nameR: '', countR: '', isSelfR: false },
      { indexL: '09', avatarL: '', nameL: '', countL: '', isSelfL: false, indexR: '10', avatarR: '', nameR: '', countR: '', isSelfR: true }
    ],
    selfRanking: {
      rank: '',
      name: '',
      count: '',
    },
    selfCount: {
      f: false,
      lastCount: 0,
      nowCount: 0
    },//用来做数字变化动画
    avatar: '',
    headUser: [],
    countDownStyle: ''
  },

  doubleReward: function (bonus) {
    var animation = wx.createAnimation({
      timingFunction: 'ease-in'
    })

    animation.rotateX(180).step({ duration: 100 })
    animation.rotateX(0).step({ duration: 100 })
    animation.rotateX(180).step({ duration: 100 })
    animation.rotateX(0).step({ duration: 100 })
    animation.rotateX(180).step({ duration: 100 })
    animation.rotateX(0).step({ duration: 100 })
    this.setData({
      rollAnimation: animation.export()
    })

    setTimeout(function () {
      var result = this.data.result
      result.bonus = bonus
      this.setData({
        result: result
      })
    }.bind(this), 500)
  },

  // countDownAnimation: function () {
  //   var animation = wx.createAnimation({
  //     duration: 600,
  //     timingFunction: 'ease-in-out',
  //   })
  //   animation.scale(1.5, 1.5).step()
  //   animation.scale(1, 1).step()
  //   this.setData({
  //     countDownAnimation: animation.export()
  //   })
  // },

  countDown: function () {
    if (this.data.network.getting) {
      this.data.network.conutDown ++
      if (this.data.network.conutDown >= 2) {
        this.data.network.problem = true
        this.data.network.conutDown = 0
        wx.showToast({
          title: '网络异常',
          icon: 'none',
          duration: 2000
        })
      }
    }
    if (!this.data.getInfo) {
      return
    }
    // console.log('interval-----' + this.data.interval + '------schedRoomPlay------' + app.server.config.schedRoomPlay)
    if (this.data.interval >= app.server.config.schedRoomPlay) {
      this.getRoomDynamicInfo()
      this.data.interval = 1
    } else {
      this.data.interval++
    } 
    var time = Number(this.data.countDown)
    time--
    if (time < 0) {
      time = 0
    }
    let now = time.toString()
    this.setData({
      countDown: now
    })
    if (this.data.status == 0) {
      if (time <= 10) {
        this.setData({
          countDownStyle: 'color: #f9723e'
        })
      }
      if (time == 0) {
        this.data.status = 4
        this.data.answer.status = -1
        this.data.questionNum += 1
        this.getQuestionEve()
      }
      
    } else if (this.data.status == 1) {
      if (time == 0) {
        this.data.status = 4
        this.data.answer.status = 0
        this.data.questionNum += 1
        this.getRanking(true)
        this.getQuestionEve()
      }
    } else if (this.data.status == 2) {

    } else if (this.data.status == 3) {

    }
    else if (this.data.status == 4) {
      if (this.data.reloadQuestion) {
        this.getQuestion()
      }
    }

    if (this.data.alwaysGetRanking) {
      this.getRanking()
    }
  },

  judgeDevice: function () {
    //判断是不是iPhone X
    if (this.data.adapter.animation == 'l') {
      this.data.adapter.head = 'margin-top: 30rpx;'
      this.data.adapter.sponsor = 'margin-top: 86rpx;'
    }
  },
  
  //传入flag需要获取题目时按服务端时间判断倒计时
  getQuestionEve: function (flag) {
    if (this.data.network.problem) {
      return
    }
    //判断是否结束了
    if (this.data.questionNum > this.data.roomInfo.questionC) {
      if (this.interval) {
        clearInterval(this.interval)
      }
      if (this.data.roomInfo.ref == 2) {
        this.toRoomRecord()
        return
      }
      this.data.answer.status = 0
      var that = this
      wx.showLoading({
        title: '奖励计算中',
      })
      setTimeout(function () {
        that.getResult()
      }.bind(that), 1000)
      
      return
    }
    //展示过渡页
    //校正获取题目的时间
    var now = new Date().getTime() + app.globalData.timeDifference
    //前面题目花时
    var pastTime = (this.data.questionNum - 1) * (this.data.roomInfo.questionCountDown * 1000 + 500)
    // console.log('pasttime----' + pastTime)
    //下一题开始时间
    if (this.data.questionNum == this.data.roomInfo.questionC) {
      pastTime = pastTime + 1500
    } else {
      pastTime = pastTime + 500
    }
    // console.log('pasttime----' + pastTime)
    var beginTime = (pastTime + this.data.roomInfo.playBeginTime) - now
    // console.log('beginTime----' + beginTime)

    if (beginTime < 0) {
      beginTime = 0
    }

    var num = ''
    var time = 500
    if (this.data.questionNum == this.data.roomInfo.questionC) {
      this.data.lastQuestion = true
      num = '最后一题'
      // time = 1500
    } else {
      num = '第' + this.data.questionNum + '题'
    }
    var qType = common.getQuestionType(this.data.questionType[this.data.questionNum - 1])
    this.data.question.t = qType
    this.data.question.n = num
    this.setData({
      lastQuestion: this.data.lastQuestion,
      status: 4,
      adapter: this.data.adapter,
      questionNum: this.data.questionNum,
      question: this.data.question
    })

    setTimeout(function () {
      this.getQuestion(flag)
    }.bind(this), beginTime)

    
  },

  //传入flag需要岩服务端时间判断倒计时
  getQuestion: function (flag) {
    // console.log(new Date().getTime() + app.globalData.timeDifference)
    if (this.data.network.problem) {
      return
    }
    this.data.reloadQuestion = false

    this.data.network.getting = true
    net.connect({
      url: url.host + url.get_room_question,
      data: {
        gameId: this.data.gameId,
        n: this.data.questionNum
      },
      success: res => {
        // console.log(new Date().getTime() + '----' + this.data.gameId + '------' + this.data.questionNum)
        wx.hideLoading()
        //已经获取请求做判断是否被中断了
        this.data.network.getting = false
        this.data.network.conutDown = 0
        if (this.data.network.problem) {
          if (this.interval) {
            clearInterval(this.interval)
          }
          this.data.network.problem = false
          this.judgeStatus()
          return
        }
        if (res.data.code == 200) {
          this.data.getDynamicInfo = false
          this.data.questionId = res.data.data.questionId
          
          if (flag) {
            var now = new Date().getTime() + app.globalData.timeDifference
            var offset = now - res.data.data.beginTime
            var offset = room_ceil((res.data.data.countDown * 1000 - offset) / 1000)
            // var offset = room_ceil((now - res.data.data.beginTime) / 1000)
            // offset = res.data.data.countDown - offset
            if (offset < 0) {
              return
              // offset = 0
            }
            var countDown = String(offset)
          } else {
            var countDown = String(this.data.roomInfo.questionCountDown)
          }
          var options = [res.data.data.a, res.data.data.b, res.data.data.c, res.data.data.d]
          options.sort(function (a, b) {
            return Math.random() > .5 ? -1 : 1
          })
          this.setData({
            status: 1,
            questionNum: this.data.questionNum,
            answer: {
              tips: '答题倒计时',
              integral: 0,
              status: -1,
            },
            optionsStyle: ['w', 'w', 'w', 'w'],
            question: { n: this.data.question.n, t: this.data.question.t, q: res.data.data.question, o: options, id: res.data.data.questionId },
            countDown: countDown,
          })
          //需要按服务器时间展示的一般是从新进入，没有排行榜数据
          if (!flag) {
            //延迟展示排行榜
            setTimeout(function () {
              this.setData({
                ranking: this.data.ranking,
                selfRanking: this.data.selfRanking
              })
            }.bind(this), 1000)
          }

        } else if (res.data.code == 20001) {
          this.backHome('脑力值不足，无法进入')
        } else if (res.data.code == 20006) {
          this.data.reloadQuestion = true
        } else if (res.data.code == 20007) {
          return
        } else if (res.data.code == 20004) {
          this.roomEnd()
        } else {
          this.backHome('此房间暂时不能进入')
        }
      }
    }, true)
  },

  getResult: function () {
    this.data.answer.status = 0
    if (this.data.network.problem) {
      return
    }
    this.data.alwaysGetRanking = false
    this.data.network.getting = true
    var that = this
    net.connect({
      url: url.host + url.get_room_result,
      data: { gameId: this.data.gameId },
      success: res => {
        //已经获取请求做判断是否被中断了
        this.data.network.getting = false
        this.data.network.conutDown = 0
        if (this.data.network.problem) {
          if (this.interval) {
            clearInterval(this.interval)
          }
          this.data.network.problem = false
          this.judgeStatus()
          return
        }
        if (res.data.code == 200) {
          this.data.getInfo = false
          that.getRanking()
          wx.hideLoading()
          // app.globalData.user.withdrawalbleFee += res.data.data.awardFee
          var bonus = Number((res.data.data.awardFee / 100).toFixed(2))
          // console.log(app.globalData.user.withdrawalbleFee)
          var openType = 'share'
          if (res.data.data.rank <= this.data.roomInfo.awardUser) {
            //有奖
            var tips = '恭喜你位列积分榜第 ' + res.data.data.rank + ' 名'
            var status = 2
            if (app.server.shareRoomResult < app.server.config.shareRoomResultMax) {
              var shareButton = '分享到群 奖金翻倍'
              var shareType = 2
              var shareTips = '群用户越多、段位越高，翻倍越大，每天能翻倍 1 次'
            } else if (app.server.shareRoomResult2 < app.server.config.shareRoomResult2Max) {
              var r = common.starToFragment(app.server.config.rankDanList, app.server.starC)
              var cell = app.server.config.rankDanList[r[0]].cellSplitMax
              var shareButton = '分享到群 赚取' + common.unit(cell) + '脑力值'
              var shareType = 1
              var shareTips = '群用户越多、脑力值奖励越多，一天只有3次奖励哦'
            } else {
              var shareButton = '分享到群 PK好友奖励'
              var shareType = 4
              var shareTips = ''
            }

          } else {
            //无奖
            var tips = '很遗憾你未进入前' + this.data.roomInfo.awardUser + '名'
            var status = 3
            if (app.server.shareRoomResult2 < app.server.config.shareRoomResult2Max) {
              var r = common.starToFragment(app.server.config.rankDanList, app.server.starC)
              var cell = app.server.config.rankDanList[r[0]].cellSplitMax
              var shareButton = '分享到群 赚取' + common.unit(cell) + '脑力值'
              var shareType = 1
              var shareTips = '群用户越多、脑力值奖励越多，一天只有3次奖励哦'
            } else {
              var shareButton = '调戏超脑小客服 求安慰'
              var shareType = 0
              openType = 'contact'
              var shareTips = ''
            }
          }
          this.setData({
            status: status,
            share: {
              t: shareType,
              s: 0
            },
            result: {
              bonus: bonus,
              tips: tips,
              shareButton: shareButton,
              shareTips: shareTips,
              openType: openType
            }
          })
        } else if (res.data.code == 20001) {
          this.backHome('脑力值不足，无法进入')
        } else if (res.data.code == 20006 || res.data.code == 20007) {
          setTimeout(function () {
            that.getResult()
          }.bind(this), 1000)
        } else if (res.data.code == 20004) {
          this.roomEnd()
        } else {
          this.backHome('此房间暂时不能进入')
        }
      }
    }, true)
  },
//传flag延迟展示
  getRanking: function (flag) {
    if (this.data.network.problem) {
      return
    }
    net.connect({
      url: url.host + url.get_room_ranking,
      data: { gameId: this.data.gameId },
      success: res => {
        if (res.data.code == 200) {
          var index = 0
          for (var i= 0; i < res.data.data.length; i ++) {
            var l = res.data.data[i]
            if (l.userId == app.server.userId) {
              if (l.rank < 10) {
                l.rank = '0' + l.rank
              }
              if (this.data.selfRanking.count != l.pointC) {
                this.data.selfCount.lastCount = this.data.selfCount.nowCount
                this.data.selfCount.nowCount = l.pointC
                this.data.selfCount.f = true
              }
              this.data.selfRanking = {
                rank: l.rank,
                name: l.nickName,
                count: l.pointC + '分'
              }
            }
            var isLeft = i % 2 == 0
            // console.log(index + '------' + isLeft)
            if (isLeft) {
              this.data.ranking[index].avatarL = l.headImg
              this.data.ranking[index].nameL = l.nickName
              this.data.ranking[index].countL = l.pointC + '分'
            } else {
              this.data.ranking[index].avatarR = l.headImg
              this.data.ranking[index].nameR = l.nickName
              this.data.ranking[index].countR = l.pointC + '分'
              index++;
            }
          }
          // console.log(this.data.ranking)
          if (!flag) {
            if (this.data.selfCount.f) {
              this.data.selfCount.f = false
              var ntc = new NumberTimeChange({
                start: this.data.selfCount.lastCount,
                end: this.data.selfCount.nowCount,
                duration: 1000,
                speed: 50,
                update: n => {
                  this.data.selfRanking.count = n + '分'
                  this.setData({
                    selfRanking: this.data.selfRanking
                  })
                },
                complete: n => {
                  this.data.selfRanking.count = n + '分'
                  this.setData({
                    ranking: this.data.ranking,
                    selfRanking: this.data.selfRanking
                  })
                }
              })
              return
            }

            this.setData({
              ranking: this.data.ranking,
              selfRanking: this.data.selfRanking
            })
          }
        } else if (res.data.code == 20001) {
          this.backHome('脑力值不足，无法进入')
        } else if (res.data.code == 20006 || res.data.code == 20007) {
          this.backHome('此房间已爆满，无法进入')
        } else if (res.data.code == 20004) {
          this.roomEnd()
        } else {
          this.backHome('此房间暂时不能进入')
        }
      }
    }, true)
  },

  answer: function (options) {

    if (this.data.answer.status != -1) {
      return
    }
    this.data.answer.status = 0
    var o = ['w', 'w', 'w', 'w']
    var id = options.currentTarget.id
    o[id] = 's'
    this.setData({
      optionsStyle: o,
    })
    var answer = this.data.question.o[id]
    this.data.network.getting = true
    var that = this
    net.connect({
      url: url.host + url.get_room_answer,
      method: 'POST',
      data: {
        gameId: this.data.gameId,
        questionId: this.data.question.id,
        optionContent: answer
      },
      success: res => {
        //已经获取请求做判断是否被中断了
        this.data.network.getting = false
        this.data.network.conutDown = 0
        if (this.data.network.problem) {
          this.data.network.problem = false
          if (this.data.countDown == 0) {
            if (this.interval) {
              clearInterval(this.interval)
            }
            this.judgeStatus()
            return
          }
        }
        this.getRanking()
        if (this.data.questionNum == this.data.roomInfo.questionC) {
          this.data.alwaysGetRanking = true
        }
        if (res.data.code == 200) {
          if (this.data.questionId != res.data.data.questionId) {
            return
          }
          o = ['q', 'q', 'q', 'q']
          if (res.data.data.addPointC > 0) {
            this.data.answer.integral = res.data.data.addPointC
            o[id] = 't'
            this.answerRightAnimation(o)
          } else {
            o[id] = 'f'
            this.answerFalseAnimation(o)
          }
          setTimeout(function () {
            this.data.answer.tips = '等待他人答题'
            this.setData({
              answer: this.data.answer
            })
          }.bind(this), 1500)
        } else if (res.data.code == 20001) {
          this.backHome('脑力值不足，无法进入')
        } else if (res.data.code == 20006) {
          var that = this
          setTimeout(function () {
            that.answer(options)
          }.bind(this), 1000)
        } else if (res.data.code == 20007) {
          return
        } else if (res.data.code == 20004) {
          this.roomEnd()
        } else if (res.data.code == 20008) {
          wx.showToast({
            title: res.data.msg,
            icon: 'none',
            mask: true,
            duration: 2000,
          })
        } else {
          this.backHome('此房间暂时不能进入')
        }
      }
    }, true)
  },

  answerFalseAnimation: function(o) {
    this.setData({
      animation: {
        status: 2,
        backgroundStyle: 'opacity: 0;'
      },
      optionsStyle: o
    })

    setTimeout(function () {
      this.setData({
        animation: {
          status: 0,
          backgroundStyle: 'opacity: 0;'
        }
      })
    }.bind(this), 1000)
  },

  answerRightAnimation: function (o) {
    this.setData({
      answer: this.data.answer,
      animation: {
        status: 1,
        backgroundStyle: 'opacity: 1;'
      },
      optionsStyle: o
    })

    setTimeout(function () {
      this.answerRightAnimationFirst()
    }.bind(this), 200)
    
  },

  answerRightAnimationFirst: function() {
    

    var animationB = wx.createAnimation({
      timingFunction: 'ease-in',
    })
    
    var animationR = wx.createAnimation({
      timingFunction: 'ease-in',
    })

    var animationS = wx.createAnimation({
      timingFunction: 'ease-in',
    })
    
    var animationH = wx.createAnimation({
      timingFunction: 'ease-in',
    })
    
    var animationT = wx.createAnimation({
      timingFunction: 'ease-in',
    })

    var animationSelfR = wx.createAnimation({
      timingFunction: 'ease-in'
    })

    animationB.opacity(1).step({ duration: 200 })//遮罩
    animationR.width('352rpx').height('352rpx').step({ duration: 400 })//光
    animationS.width('300rpx').height('204rpx').step({ duration: 400, delay: 200 })//星星
    animationS.width('200rpx').height('136rpx').step({ duration: 300 })
    animationH.opacity(1).step({ duration: 100, delay: 200 })//钩
    animationH.top('210rpx').step({ duration: 100 })
    animationT.opacity(1).step({ duration: 100, delay: 200 })//字
    animationT.top('298rpx').step({ duration: 100 })
    
    animationSelfR.scale(1.3).width('360rpx').translateX(-23.5).step({ duration: 300 })

    this.setData({
      animation: {
        status: 1,
        backgroundStyle: 'opacity: 1;',
        answerBg: animationB.export(),
        answerRightBg: animationR.export(),
        answerRightStar: animationS.export(),
        answerRightHook: animationH.export(),
        answerRightText: animationT.export(),
        selfRanking: animationSelfR.export()
      }
    })

    setTimeout(function () {
      animationB.scale(0.1).opacity(0).step({ duration: 200 })
      animationR.width('0rpx').height('0rpx').opacity(0).step({ duration: 200 })
      animationS.width('0rpx').height('0rpx').opacity(0).step({ duration: 200 })
      animationH.scale(0.1).opacity(0).step({ duration: 200 })
      animationT.scale(0.1).opacity(0).step({ duration: 200 })
      animationSelfR.scale(1).width('311rpx').translateX(0).step({ duration: 200})
      
      this.setData({
        animation: {
          status: 1,
          backgroundStyle: 'opacity: 1;',
          answerBg: animationB.export(),
          answerRightBg: animationR.export(),
          answerRightStar: animationS.export(),
          answerRightHook: animationH.export(),
          answerRightText: animationT.export(),
          selfRanking: animationSelfR.export()
        }
      })

      setTimeout(function () {
        animationB.scale(1).step({ duration: 100 })
        animationR.width('0px').height('0px').opacity(1).step({ duration: 100 })
        animationS.width('0px').height('0px').opacity(1).step({ duration: 100 })
        animationH.scale(1).top('240rpx').step({ duration: 100 })
        animationT.scale(1).top('328rpx').step({ duration: 100 })

        this.setData({
          animation: {
            status: 1,
            backgroundStyle: 'opacity: 0;',
            answerBg: animationB.export(),
            answerRightBg: animationR.export(),
            answerRightStar: animationS.export(),
            answerRightHook: animationH.export(),
            answerRightText: animationT.export(),
          }
        })

        setTimeout(function () {
          this.setData({
            animation: {
              status: 0
            }
          })
        }.bind(this), 100)

      }.bind(this), 200)

    }.bind(this), 1200)
  },

  //空方法，用来冒泡到底层方法
  empty: function () {
    // console.log('kong')
  },

  roomEnd: function () {
    if (this.data.roomInfo.ref == 2) {
      this.toRoomRecord()
      return
    }
    this.backHome('此房间已结束，无法进入')
  },

  entryRoom: function () {
    net.connect({
      url: url.host + url.entry_room,
      data: {
        gameId: this.data.gameId
      },
      method: "POST",
      success: res => {
        if (res.data.code == 200) {
          app.globalData.user.cell -= res.data.data.costCell
          app.globalData.user.playGameC += res.data.data.play
          this.getRoomInfo(res.data.data.costCell)
        } else if (res.data.code == 20001) {
          this.backHome('脑力值不足，无法进入')
        } else if (res.data.code == 20006) {
          var that = this
          setTimeout(function () {
            that.entryRoom()
          }.bind(this), 1000)
        } else if (res.data.code == 20004) {
          this.roomEnd()
        } else if (res.data.code == 20007) {
          this.backHome('此房间已爆满，无法进入')//正常来说平台房间才返回
        } else {
          this.backHome('此房间暂时不能进入')
        }
        
      } 
    }, true)
  },

  getRoomInfo: function (cell) {
    net.connect({
      url: url.host + url.get_room_info,
      data: {
        gameId: this.data.gameId
      },
      success: res => {
        wx.hideLoading()
        if (res.data.code == 200) {
          this.data.getInfo = true
          this.data.getDynamicInfo = true
          this.data.roomInfo = res.data.data
          this.getRoomDynamicInfo()

          // var now = new Date().getTime() + app.globalData.timeDifference
          // var countDown = room_ceil((res.data.data.playBeginTime - now) / 1000)
          // if (countDown < 0) {
          //   countDown = 0
          // }
          var icon = ''
          if (res.data.data.ref == 1) {
            icon = '../../resource/room_tag_g.png'
          } else if (res.data.data.ref == 2) {
            icon = '../../resource/room_tag_j.png'
          }
          
          res.data.data.awardFee = Number((res.data.data.awardFee / 100).toFixed(2))

          this.data.questionType = res.data.data.questionTags.split('#')

          var arr = getCurrentPages()
          if (arr.length > 1 && res.data.data.ref == 2) {
            this.data.invite.shareButton = '继续邀请好友 参与答题'
            this.data.invite.shareTips1 = '未被领取奖金将于答题结束后退回',
            this.data.invite.shareTips2 = ''
          }

          this.data.selfRanking.name = app.globalData.userInfo.nickName

          var sponsor = res.data.data.desc
          if (sponsor.length > 12) {
            sponsor = sponsor.substring(0, 12)
          }

          this.setData({
            // countDown: String(countDown),
            roomInfo: this.data.roomInfo,
            sponsor: { name: '由 ' + sponsor + ' 冠名', icon: icon },
            numOfPeople: res.data.data.curUser,
            invite: this.data.invite,
            selfRanking: this.data.selfRanking
          })

          this.judgeStatus()

          if (cell > 0) {
            app.server.playRoom ++
            wx.showToast({
              title: '消耗' + common.unit(cell) + '脑力值',
              icon: 'none',
              duration: 2000
            })
          }

        } else if (res.data.code == 20001) {
          this.backHome('脑力值不足，无法进入')
        } else if (res.data.code == 20006 || res.data.code == 20007) {
          this.backHome('此房间已爆满，无法进入')
        } else if (res.data.code == 20004) {
          this.roomEnd()
        } else {
          this.backHome('此房间暂时不能进入')
        }
         
      }
    }, true)
  },

  getRoomDynamicInfo: function () {
    // console.log(this.data.getDynamicInfo + '-----' + this.data.roomInfo.ref)
    if (!this.data.getDynamicInfo && this.data.roomInfo.ref == 1) {
      return
    }
    net.connect({
      url: url.host + url.get_room_dynamic_info,
      data: {
        gameId: this.data.gameId
      },
      success: res => {
        if (res.data.code == 200) {
          this.setData({
            headUser: res.data.data.lastUserList,
            numOfPeople: res.data.data.curUser
          })
        }
      }
    }, true)
  },

  createImage: function () {
    wx.previewImage({
      urls: ['https://brain.xsbanruo.com/share.jpg'],
    })
    // console.log('createImage')
  },

  backHome: function(tips) {
    wx.showToast({
      title: tips,
      icon: 'none',
      mask: true,
      duration: 2000,
    })
    setTimeout(function () {
      var arr = getCurrentPages()
      if (arr.length == 1) {
        wx.redirectTo({
          url: '/pages/home/home',
        })
      } else {
        wx.navigateBack({
        })
      }
    }.bind(this), 2000)
  },

  toRoomRecord: function () {
    wx.redirectTo({
      url: '/pages/roomRecord/roomRecord?gameId=' + this.data.gameId + '&shareUserId=' + this.data.shareUserId
    })
  },
  
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // console.log(options)
    //分享目标页面需要写的
    if (options.recomCode) {
      app.globalData.identify.recomCode = options.recomCode
      app.globalData.identify.shareIdentify = options.shareIdentify
    }
    this.data.gameId = options.gameId
    if (options.type) {
      this.data.roomInfo.ref = options.type
    }
    if (options.shareUserId) {
      this.data.shareUserId = options.shareUserId
    }
    wx.hideShareMenu({})
    if (app.globalData.sys.screenHeight / app.globalData.sys.screenWidth >= 1.85) {
      this.setData({
        adapter: {
          sponsor: 'margin-top: 86rpx;',
          avatar: 'top: 110rpx;',
          answer: 'top: 410rpx;margin-bottom: 68rpx;',
          bonus: 'margin-top: -104rpx;box-shadow: 0px 0px 0px #32302c;',
          num: 'margin-top: 8rpx;',
          resultRanking: 'margin-top: 8rpx;',
          resultBonus: 'margin-top: 26rpx;',
          resultMiddle: 'height: 252rpx;',

          animation: 'l'
        },
      })
    }
    this.entryRoom()
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    if (this.interval) {
      clearInterval(this.interval)
    }
    if (this.data.status == 2 || this.data.status == 3) {
      return
    }
    if (this.data.isFirstLoad) {
      wx.showLoading({
        title: '',
      })
      // console.log('间隔' + this.data.interval)
      // this.interval = setInterval(function (data) {
      //   this.countDown()
      // }.bind(this), 1000)
      this.data.isFirstLoad = false
    } else {
      if (this.data.getDynamicInfo) {
        this.getRoomDynamicInfo()
      }
      if (this.data.getInfo) {
        this.judgeStatus(true)
      }
    }
    
  },
// 传flag就展示longing
  judgeStatus: function (flag) {
    if (flag) {
      wx.showLoading({
        title: '稍等',
        mask: true
      })
    }
    var now = new Date().getTime() + app.globalData.timeDifference
    if (now > this.data.roomInfo.playEndTime) {
      // console.log('end')
      if (this.data.roomInfo.ref == 2) {
        this.toRoomRecord()
        return
      }
      if (this.data.status != 2 || this.data.status != 3) {
          this.getResult()
      }
    } else if (now > this.data.roomInfo.playBeginTime) {
      // console.log('answer')
      var offset = (now - this.data.roomInfo.playBeginTime) / 1000
      var n = room_ceil(offset / (this.data.roomInfo.questionCountDown + 0.5))
      this.data.questionNum = n
      //判断是否最后一题，最后一题需要判断展示过渡页否
      if (this.data.questionNum == this.data.roomInfo.questionC) {
        var frontQuestionT = (n - 1) * (this.data.roomInfo.questionCountDown + 0.5)
        //实际耗时比前面题目耗时多于过渡时间就忽略过渡页
        if (offset - frontQuestionT > 1.5) {
          this.getQuestion(true)
        } else {
          this.getQuestionEve(true)
        }
      } else {
        this.getQuestion(true)
      }
      
      this.interval = setInterval(function (data) {
        this.countDown()
      }.bind(this), 1000)
    } else if (now > this.data.roomInfo.beginTime) {
      // console.log('countDown')
      var countDown = room_ceil((this.data.roomInfo.playBeginTime - now) / 1000)
      if (countDown < 0) {
        countDown = 0
      }
      this.setData({
        status: 0,
        countDown: countDown
      })
      wx.hideLoading()
      this.countDown()
      this.interval = setInterval(function (data) {
        this.countDown()
      }.bind(this), 1000)
    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {
    if (this.interval) {
      clearInterval(this.interval)
    }
  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    if (this.interval) {
      clearInterval(this.interval)
    }
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
  
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
  
  },

  /**
   * 用户点击右上角分享
   */
  //结果分享0分享房间，1增加脑力值，2翻倍,3图片, 4无奖励
  onShareAppMessage: function () {
    wx.showShareMenu({
      withShareTicket: true
    })
    var path = ''
    if (this.data.share.t == 0) {
      path = '&page=room&gameId=' + this.data.gameId + '&type=' + this.data.roomInfo.ref + '&shareUserId=' + app.server.userId
      if (this.data.roomInfo.ref == 1) {
        var title = app.globalData.userInfo.nickName + ' 邀请你来瓜分8万8千8百8十8元现金奖励'
      }
      else if (this.data.roomInfo.ref == 2) {
        var title = '金主' + this.data.roomInfo.desc + '撒钱了，60秒内速速加入抢大钱'
      }
      var t = 3
    } else if (this.data.share.t == 1) {
      var title = app.globalData.userInfo.nickName + ' 邀请你来瓜分8万8千8百8十8元现金奖励'
      var t = 5
    } else if (this.data.share.t == 2) {
      var title = app.globalData.userInfo.nickName + ' 正在用脑力征服世界并瓜分了888元现金奖励'
      var t = 4
    } else if (this.data.share.t == 4) {
      var title = app.globalData.userInfo.nickName + ' 正在用脑力征服世界并瓜分了888元现金奖励'
      var t = 6
    }
    var that = this
    app.log('path------' + path)
    return common.shareAction({
      path: path,
      title: title,
      gameId: this.data.gameId,
      type: t,
      success: res=> {
        wx.hideShareMenu({})
        if (res.data.data.addFee > 0) {
          // app.globalData.user.withdrawalbleFee += res.data.data.addFee
          var addFee = Number((res.data.data.addFee / 100).toFixed(2))
          var share = that.data.share
          share.bonus = addFee
          share.s = 2
          that.setData({
            share: share,
          })

          setTimeout(function () {
            var result = this.data.result
            result.shareButton = '生成奖励图片 分享给好友'
            result.shareTips = '生成奖励图片分享给好友，获取更多奖金翻倍机会'
            result.openType = ''
            share.s = 0
            that.setData({
              share: share
            })
            that.doubleReward((addFee + result.bonus).toFixed(2))
          }.bind(that), 2000)
        } else if (res.data.data.addCell > 0) {
          var share = that.data.share
          share.cell = res.data.data.addCell
          share.s = 1
          that.setData({
            share: share,
          })

          if (that.data.share.t == 1 && app.server.shareRoomResult2 >= app.server.config.shareRoomResult2Max) {
            if (that.data.result.bonus == 0) {
              that.data.result.shareButton = '调戏超脑小客服 求安慰'
              that.data.result.shareType = 0
              that.data.result.openType = 'contact'
              that.data.result.shareTips = ''
            } else {
              that.data.result.shareButton = '分享到群 PK好友奖励'
              that.data.result.shareType = 4
              that.data.result.openType = 'share'
              that.data.result.shareTips = ''
            }
          }

          setTimeout(function () {
            share.s = 0
            that.setData({
              share: share,
              result: that.data.result
            })
          }.bind(that), 2000)
        }
      },
      fail: e=> {
        wx.hideShareMenu({})
      }
    })
  }
})

function room_ceil(num) {
  // console.log(num)
  var n = num
  // console.log(Math.ceil(Number(n.toFixed(2))))
  return Math.ceil(Number(n.toFixed(2)))
}